variables:
  DOCKER_HOST: tcp://docker:2375
  DOCKER_REGISTRY: 303912000210.dkr.ecr.eu-central-1.amazonaws.com
  APP_NAME: account-data

stages:
  - build
  - test
  - deploy

build:
  stage: build
  image: 
    name: amazon/aws-cli
    entrypoint: [""]
  services:
    - docker:dind
  before_script:
    - amazon-linux-extras install docker
  script:
    - docker build -t $DOCKER_REGISTRY/$APP_NAME:latest .
    - docker tag $DOCKER_REGISTRY/$APP_NAME:latest $DOCKER_REGISTRY/$APP_NAME:$CI_PIPELINE_IID
    - aws ecr get-login-password | docker login --username AWS --password-stdin $DOCKER_REGISTRY
    - docker push $DOCKER_REGISTRY/$APP_NAME:latest
    - docker push $DOCKER_REGISTRY/$APP_NAME:$CI_PIPELINE_IID

test:
  stage: test
  image: 
    name: amazon/aws-cli
    entrypoint: [""]
  services:
    - docker:dind
  before_script:
    - amazon-linux-extras install docker
  script:
    - aws ecr get-login-password | docker login --username AWS --password-stdin $DOCKER_REGISTRY
    - docker run $DOCKER_REGISTRY/$APP_NAME npm run test

deploy:
  stage: deploy
  image: 
    name: amazon/aws-cli
    entrypoint: [""]
  variables:
    AWS_ECS_CLUSTER: account-data-cluster
    AWS_ECS_SERVICE: account-data-service
    AWS_ECS_TASK_DEFINITION: account-data-td
  before_script:
    - IMAGE_TAG="$(echo $CI_COMMIT_SHA | head -c 8)"
  script:
    - aws ecs update-service --region $AWS_DEFAULT_REGION --cluster $AWS_ECS_CLUSTER --service $AWS_ECS_SERVICE --task-definition $AWS_ECS_TASK_DEFINITION --force-new-deployment
